
C ========== begin copyright notice ==============
C This file is part of 
C ---------------
C xaifBooster
C ---------------
C Distributed under the BSD license as follows:
C Copyright (c) 2005, The University of Chicago
C All rights reserved.
C
C Redistribution and use in source and binary forms, 
C with or without modification, are permitted provided that the following conditions are met:
C
C    - Redistributions of source code must retain the above copyright notice, 
C      this list of conditions and the following disclaimer.
C    - Redistributions in binary form must reproduce the above copyright notice, 
C      this list of conditions and the following disclaimer in the documentation 
C      and/or other materials provided with the distribution.
C    - Neither the name of The University of Chicago nor the names of its contributors 
C      may be used to endorse or promote products derived from this software without 
C      specific prior written permission.
C
C THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
C EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
C OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
C SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
C INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
C PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
C INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
C LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
C OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
C 
C General Information:
C xaifBooster is intended for the transformation of 
C numerical programs represented as xml files according 
C to the XAIF schema. It is part of the OpenAD framework. 
C The main application is automatic 
C differentiation, i.e. the generation of code for 
C the computation of derivatives. 
C The following people are the principal authors of the 
C current version: 
C 	Uwe Naumann
C	Jean Utke
C Additional contributors are: 
C	Andrew Lyons
C	Peter Fine
C
C For more details about xaifBooster and its use in OpenAD please visit:
C   http://www.mcs.anl.gov/openad
C
C This work is partially supported by:
C 	NSF-ITR grant OCE-0205590
C ========== end copyright notice ==============

      SUBROUTINE head(NX, NY, X, FVEC, R)
          use OAD_tape
          use OAD_rev

          ! original arguments get inserted before version
          ! and declared here together with all local variables
          ! generated by xaifBooster

      use w2f__types
      use OAD_active
      IMPLICIT NONE
C
C     **** Global Variables & Derived Type Definitions ****
C
      INTEGER(w2f__i8) OpenAD_Symbol_0
      INTEGER(w2f__i8) OpenAD_Symbol_1
      INTEGER(w2f__i8) OpenAD_Symbol_10
      INTEGER(w2f__i8) OpenAD_Symbol_11
      INTEGER(w2f__i8) OpenAD_Symbol_12
      INTEGER(w2f__i8) OpenAD_Symbol_13
      INTEGER(w2f__i8) OpenAD_Symbol_14
      INTEGER(w2f__i8) OpenAD_Symbol_15
      INTEGER(w2f__i8) OpenAD_Symbol_16
      INTEGER(w2f__i8) OpenAD_Symbol_17
      INTEGER(w2f__i8) OpenAD_Symbol_18
      INTEGER(w2f__i8) OpenAD_Symbol_19
      INTEGER(w2f__i8) OpenAD_Symbol_2
      INTEGER(w2f__i8) OpenAD_Symbol_20
      INTEGER(w2f__i8) OpenAD_Symbol_21
      INTEGER(w2f__i8) OpenAD_Symbol_22
      INTEGER(w2f__i8) OpenAD_Symbol_23
      INTEGER(w2f__i8) OpenAD_Symbol_24
      INTEGER(w2f__i8) OpenAD_Symbol_25
      INTEGER(w2f__i8) OpenAD_Symbol_26
      INTEGER(w2f__i8) OpenAD_Symbol_27
      INTEGER(w2f__i8) OpenAD_Symbol_28
      INTEGER(w2f__i8) OpenAD_Symbol_29
      INTEGER(w2f__i8) OpenAD_Symbol_3
      INTEGER(w2f__i8) OpenAD_Symbol_30
      INTEGER(w2f__i8) OpenAD_Symbol_31
      INTEGER(w2f__i8) OpenAD_Symbol_32
      INTEGER(w2f__i8) OpenAD_Symbol_33
      INTEGER(w2f__i8) OpenAD_Symbol_34
      INTEGER(w2f__i8) OpenAD_Symbol_35
      INTEGER(w2f__i8) OpenAD_Symbol_36
      INTEGER(w2f__i8) OpenAD_Symbol_37
      INTEGER(w2f__i8) OpenAD_Symbol_38
      INTEGER(w2f__i8) OpenAD_Symbol_39
      INTEGER(w2f__i8) OpenAD_Symbol_4
      INTEGER(w2f__i8) OpenAD_Symbol_40
      INTEGER(w2f__i8) OpenAD_Symbol_41
      INTEGER(w2f__i8) OpenAD_Symbol_42
      INTEGER(w2f__i8) OpenAD_Symbol_43
      INTEGER(w2f__i8) OpenAD_Symbol_44
      INTEGER(w2f__i8) OpenAD_Symbol_45
      INTEGER(w2f__i8) OpenAD_Symbol_46
      INTEGER(w2f__i8) OpenAD_Symbol_47
      INTEGER(w2f__i8) OpenAD_Symbol_48
      INTEGER(w2f__i8) OpenAD_Symbol_49
      INTEGER(w2f__i8) OpenAD_Symbol_5
      INTEGER(w2f__i8) OpenAD_Symbol_50
      INTEGER(w2f__i8) OpenAD_Symbol_51
      INTEGER(w2f__i8) OpenAD_Symbol_52
      INTEGER(w2f__i8) OpenAD_Symbol_53
      INTEGER(w2f__i8) OpenAD_Symbol_54
      INTEGER(w2f__i8) OpenAD_Symbol_55
      INTEGER(w2f__i8) OpenAD_Symbol_56
      INTEGER(w2f__i8) OpenAD_Symbol_57
      INTEGER(w2f__i8) OpenAD_Symbol_58
      INTEGER(w2f__i8) OpenAD_Symbol_59
      INTEGER(w2f__i8) OpenAD_Symbol_6
      INTEGER(w2f__i8) OpenAD_Symbol_60
      INTEGER(w2f__i8) OpenAD_Symbol_61
      INTEGER(w2f__i8) OpenAD_Symbol_62
      INTEGER(w2f__i8) OpenAD_Symbol_63
      INTEGER(w2f__i8) OpenAD_Symbol_64
      INTEGER(w2f__i8) OpenAD_Symbol_65
      INTEGER(w2f__i8) OpenAD_Symbol_66
      INTEGER(w2f__i8) OpenAD_Symbol_67
      INTEGER(w2f__i8) OpenAD_Symbol_68
      INTEGER(w2f__i8) OpenAD_Symbol_69
      INTEGER(w2f__i8) OpenAD_Symbol_7
      INTEGER(w2f__i8) OpenAD_Symbol_70
      INTEGER(w2f__i8) OpenAD_Symbol_71
      INTEGER(w2f__i8) OpenAD_Symbol_72
      INTEGER(w2f__i8) OpenAD_Symbol_73
      INTEGER(w2f__i8) OpenAD_Symbol_74
      INTEGER(w2f__i8) OpenAD_Symbol_75
      INTEGER(w2f__i8) OpenAD_Symbol_76
      INTEGER(w2f__i8) OpenAD_Symbol_77
      INTEGER(w2f__i8) OpenAD_Symbol_78
      INTEGER(w2f__i8) OpenAD_Symbol_79
      INTEGER(w2f__i8) OpenAD_Symbol_8
      INTEGER(w2f__i8) OpenAD_Symbol_80
      INTEGER(w2f__i8) OpenAD_Symbol_81
      INTEGER(w2f__i8) OpenAD_Symbol_82
      INTEGER(w2f__i8) OpenAD_Symbol_83
      INTEGER(w2f__i8) OpenAD_Symbol_9
      REAL(w2f__8) OpenAD_acc_0
      REAL(w2f__8) OpenAD_acc_1
      REAL(w2f__8) OpenAD_acc_10
      REAL(w2f__8) OpenAD_acc_11
      REAL(w2f__8) OpenAD_acc_12
      REAL(w2f__8) OpenAD_acc_13
      REAL(w2f__8) OpenAD_acc_14
      REAL(w2f__8) OpenAD_acc_15
      REAL(w2f__8) OpenAD_acc_16
      REAL(w2f__8) OpenAD_acc_17
      REAL(w2f__8) OpenAD_acc_18
      REAL(w2f__8) OpenAD_acc_19
      REAL(w2f__8) OpenAD_acc_2
      REAL(w2f__8) OpenAD_acc_20
      REAL(w2f__8) OpenAD_acc_3
      REAL(w2f__8) OpenAD_acc_4
      REAL(w2f__8) OpenAD_acc_5
      REAL(w2f__8) OpenAD_acc_6
      REAL(w2f__8) OpenAD_acc_7
      REAL(w2f__8) OpenAD_acc_8
      REAL(w2f__8) OpenAD_acc_9
      REAL(w2f__8) OpenAD_lin_0
      REAL(w2f__8) OpenAD_lin_10
      REAL(w2f__8) OpenAD_lin_13
      REAL(w2f__8) OpenAD_lin_16
      REAL(w2f__8) OpenAD_lin_19
      REAL(w2f__8) OpenAD_lin_2
      REAL(w2f__8) OpenAD_lin_22
      REAL(w2f__8) OpenAD_lin_25
      REAL(w2f__8) OpenAD_lin_28
      REAL(w2f__8) OpenAD_lin_31
      REAL(w2f__8) OpenAD_lin_34
      REAL(w2f__8) OpenAD_lin_37
      REAL(w2f__8) OpenAD_lin_4
      REAL(w2f__8) OpenAD_lin_41
      REAL(w2f__8) OpenAD_lin_42
      REAL(w2f__8) OpenAD_lin_44
      REAL(w2f__8) OpenAD_lin_45
      REAL(w2f__8) OpenAD_lin_46
      REAL(w2f__8) OpenAD_lin_48
      REAL(w2f__8) OpenAD_lin_49
      REAL(w2f__8) OpenAD_lin_7
      type(active) :: OpenAD_prop_0
      type(active) :: OpenAD_prop_1
      type(active) :: OpenAD_prop_10
      type(active) :: OpenAD_prop_11
      type(active) :: OpenAD_prop_2
      type(active) :: OpenAD_prop_3
      type(active) :: OpenAD_prop_4
      type(active) :: OpenAD_prop_5
      type(active) :: OpenAD_prop_6
      type(active) :: OpenAD_prop_7
      type(active) :: OpenAD_prop_8
      type(active) :: OpenAD_prop_9
      REAL(w2f__8) OpenAD_tmp_0
      REAL(w2f__8) OpenAD_tmp_1
      REAL(w2f__8) OpenAD_tmp_10
      REAL(w2f__8) OpenAD_tmp_11
      REAL(w2f__8) OpenAD_tmp_12
      REAL(w2f__8) OpenAD_tmp_13
      REAL(w2f__8) OpenAD_tmp_14
      REAL(w2f__8) OpenAD_tmp_15
      REAL(w2f__8) OpenAD_tmp_16
      REAL(w2f__8) OpenAD_tmp_17
      REAL(w2f__8) OpenAD_tmp_18
      REAL(w2f__8) OpenAD_tmp_19
      REAL(w2f__8) OpenAD_tmp_2
      REAL(w2f__8) OpenAD_tmp_20
      REAL(w2f__8) OpenAD_tmp_21
      REAL(w2f__8) OpenAD_tmp_22
      REAL(w2f__8) OpenAD_tmp_3
      REAL(w2f__8) OpenAD_tmp_4
      REAL(w2f__8) OpenAD_tmp_5
      REAL(w2f__8) OpenAD_tmp_6
      REAL(w2f__8) OpenAD_tmp_7
      REAL(w2f__8) OpenAD_tmp_8
      REAL(w2f__8) OpenAD_tmp_9
C
C     **** Parameters and Result ****
C
      INTEGER(w2f__i4) NX
      INTEGER(w2f__i4) NY
      type(active) :: X(1:INT((NX*NY)))
      type(active) :: FVEC(1:INT((NX*NY)))
      REAL(w2f__8) R
C
C     **** Local Variables and Functions ****
C
      type(active) :: DPDX
      type(active) :: DPDY
      REAL(w2f__8) FOUR
      PARAMETER ( FOUR = 4.0D00)
      REAL(w2f__8) HX
      REAL(w2f__8) HX2
      REAL(w2f__8) HY
      REAL(w2f__8) HY2
      INTEGER(w2f__i4) I
      INTEGER(w2f__i4) J
      INTEGER(w2f__i4) K
      INTEGER(w2f__i4) N
      REAL(w2f__8) NXP1
      REAL(w2f__8) NYP1
      REAL(w2f__8) ONE
      PARAMETER ( ONE = 1.0D00)
      type(active) :: P
      type(active) :: PB
      type(active) :: PBB
      type(active) :: PBL
      type(active) :: PBLAP
      type(active) :: PBR
      type(active) :: PL
      type(active) :: PLAP
      type(active) :: PLL
      type(active) :: PLLAP
      type(active) :: PR
      type(active) :: PRLAP
      type(active) :: PRR
      type(active) :: PT
      type(active) :: PTL
      type(active) :: PTLAP
      type(active) :: PTR
      type(active) :: PTT
      REAL(w2f__8) THREE
      PARAMETER ( THREE = 3.0D00)
      REAL(w2f__8) TWO
      PARAMETER ( TWO = 2.0D00)
      REAL(w2f__8) ZERO
      PARAMETER ( ZERO = 0.0D00)
      INTEGER(w2f__i8) OpenAD_Symbol_100
      INTEGER(w2f__i8) OpenAD_Symbol_101
      INTEGER(w2f__i8) OpenAD_Symbol_102
      INTEGER(w2f__i8) OpenAD_Symbol_103
      INTEGER(w2f__i8) OpenAD_Symbol_104
      INTEGER(w2f__i8) OpenAD_Symbol_105
      REAL(w2f__8) OpenAD_Symbol_106
      REAL(w2f__8) OpenAD_Symbol_107
      REAL(w2f__8) OpenAD_Symbol_108
      REAL(w2f__8) OpenAD_Symbol_109
      REAL(w2f__8) OpenAD_Symbol_110
      REAL(w2f__8) OpenAD_Symbol_111
      REAL(w2f__8) OpenAD_Symbol_112
      REAL(w2f__8) OpenAD_Symbol_113
      REAL(w2f__8) OpenAD_Symbol_114
      REAL(w2f__8) OpenAD_Symbol_115
      REAL(w2f__8) OpenAD_Symbol_116
      REAL(w2f__8) OpenAD_Symbol_117
      INTEGER(w2f__i8) OpenAD_Symbol_118
      INTEGER(w2f__i8) OpenAD_Symbol_119
      INTEGER(w2f__i8) OpenAD_Symbol_120
      INTEGER(w2f__i8) OpenAD_Symbol_121
      INTEGER(w2f__i8) OpenAD_Symbol_122
      INTEGER(w2f__i8) OpenAD_Symbol_123
      INTEGER(w2f__i8) OpenAD_Symbol_124
      INTEGER(w2f__i8) OpenAD_Symbol_125
      INTEGER(w2f__i8) OpenAD_Symbol_126
      INTEGER(w2f__i8) OpenAD_Symbol_127
      INTEGER(w2f__i8) OpenAD_Symbol_128
      INTEGER(w2f__i8) OpenAD_Symbol_129
      INTEGER(w2f__i8) OpenAD_Symbol_130
      INTEGER(w2f__i8) OpenAD_Symbol_131
      INTEGER(w2f__i8) OpenAD_Symbol_132
      INTEGER(w2f__i8) OpenAD_Symbol_133
      INTEGER(w2f__i8) OpenAD_Symbol_84
      INTEGER(w2f__i8) OpenAD_Symbol_85
      INTEGER(w2f__i8) OpenAD_Symbol_86
      INTEGER(w2f__i8) OpenAD_Symbol_87
      INTEGER(w2f__i8) OpenAD_Symbol_88
      INTEGER(w2f__i8) OpenAD_Symbol_89
      INTEGER(w2f__i8) OpenAD_Symbol_90
      INTEGER(w2f__i8) OpenAD_Symbol_91
      INTEGER(w2f__i8) OpenAD_Symbol_92
      INTEGER(w2f__i8) OpenAD_Symbol_93
      INTEGER(w2f__i8) OpenAD_Symbol_94
      INTEGER(w2f__i8) OpenAD_Symbol_95
      INTEGER(w2f__i8) OpenAD_Symbol_96
      INTEGER(w2f__i8) OpenAD_Symbol_97
      INTEGER(w2f__i8) OpenAD_Symbol_98
      INTEGER(w2f__i8) OpenAD_Symbol_99


          integer iaddr
          external iaddr
C
C     **** Top Level Pragmas ****
C
C$OPENAD INDEPENDENT(X)
C$OPENAD DEPENDENT(FVEC)
C
C     **** Statements ****
C

         if (our_rev_mode%plain) then
! original function
C$OPENAD XXX Template ad_template.f
      N = (NX * NY)
      NXP1 = (NX + 1)
      NYP1 = (NY + 1)
      HX = (1.0D00 / NXP1)
      HY = (1.0D00 / NYP1)
      HY2 = (HY * HY)
      HX2 = (HX * HX)
      DO I = 1, NY, 1
        DO J = 1, NX, 1
          K = (J + NX *(I +(-1)))
          IF((I .eq. 1) .OR.(J .eq. 1)) THEN
            PBL%v = 0.0D00
          ELSE
            PBL%v = X(K-NX+(-1))%v
          ENDIF
          IF(I .eq. 1) THEN
            PB%v = 0.0D00
            PBB%v = X(K)%v
          ELSE
            IF(I .eq. 2) THEN
              PB%v = X(K-NX)%v
              PBB%v = 0.0D00
            ELSE
              PB%v = X(K-NX)%v
              PBB%v = X(K-NX*2)%v
            ENDIF
          ENDIF
          IF((NX .eq. J) .OR.(I .eq. 1)) THEN
            PBR%v = 0.0D00
          ELSE
            PBR%v = X(K-NX+1)%v
          ENDIF
          IF(J .eq. 1) THEN
            PL%v = 0.0D00
            PLL%v = X(K)%v
          ELSE
            IF(J .eq. 2) THEN
              PL%v = X(K+(-1))%v
              PLL%v = 0.0D00
            ELSE
              PL%v = X(K+(-1))%v
              PLL%v = X(K+(-2))%v
            ENDIF
          ENDIF
          P%v = X(K)%v
          IF(J .eq.(NX +(-1))) THEN
            PR%v = X(K+1)%v
            PRR%v = 0.0D00
          ELSE
            IF(NX .eq. J) THEN
              PR%v = 0.0D00
              PRR%v = X(K)%v
            ELSE
              PR%v = X(K+1)%v
              PRR%v = X(K+2)%v
            ENDIF
          ENDIF
          IF((NY .eq. I) .OR.(J .eq. 1)) THEN
            PTL%v = 0.0D00
          ELSE
            PTL%v = X(NX+K+(-1))%v
          ENDIF
          IF(I .eq.(NY +(-1))) THEN
            PT%v = X(NX+K)%v
            PTT%v = 0.0D00
          ELSE
            IF(NY .eq. I) THEN
              PT%v = 0.0D00
              PTT%v = X(K)%v
            ELSE
              PT%v = X(NX+K)%v
              PTT%v = X(K+NX*2)%v
            ENDIF
          ENDIF
          IF((NX .eq. J) .OR.(NY .eq. I)) THEN
            PTR%v = 0.0D00
          ELSE
            PTR%v = X(NX+K+1)%v
          ENDIF
          DPDY%v = ((PT%v-PB%v)/(HY*2.0D00))
          DPDX%v = ((PR%v-PL%v)/(HX*2.0D00))
          PBLAP%v = (((PBB%v+P%v-PB%v*2.0D00)/HY2)+((PBL%v+PBR%v-PB%v*2.
     +0D00)/HX2))
          PLLAP%v = (((PBL%v+PTL%v-PL%v*2.0D00)/HY2)+((PLL%v+P%v-PL%v*2.
     +0D00)/HX2))
          PLAP%v = (((PB%v+PT%v-P%v*2.0D00)/HY2)+((PL%v+PR%v-P%v*2.0D00)
     +/HX2))
          PRLAP%v = (((P%v+PRR%v-PR%v*2.0D00)/HX2)+((PBR%v+PTR%v-PR%v*2.
     +0D00)/HY2))
          PTLAP%v = (((P%v+PTT%v-PT%v*2.0D00)/HY2)+((PTL%v+PTR%v-PT%v*2.
     +0D00)/HX2))
          FVEC(INT(K))%v = (((PBLAP%v+PTLAP%v-PLAP%v*2.0D00)/HY2)+((PLLA
     +P%v+PRLAP%v-PLAP%v*2.0D00)/HX2)-R*(((DPDY%v*(PRLAP%v-PLLAP%v))/(HX
     +*2.0D00))-((DPDX%v*(PTLAP%v-PBLAP%v))/(HY*2.0D00))))
        END DO
      END DO

          end if
          if (our_rev_mode%tape) then
! taping
C$OPENAD XXX Template ad_template.f
      N = (NX * NY)
      NXP1 = (NX + 1)
      NYP1 = (NY + 1)
      HX = (1.0D00 / NXP1)
      HY = (1.0D00 / NYP1)
      HY2 = (HY * HY)
      HX2 = (HX * HX)
      OpenAD_Symbol_16 = 0_w2f__i8
      DO I = 1, NY, 1
        OpenAD_Symbol_17 = 0_w2f__i8
        DO J = 1, NX, 1
          K = (J + NX *(I +(-1)))
          IF((I .eq. 1) .OR.(J .eq. 1)) THEN
            PBL%v = 0.0D00
            OpenAD_Symbol_18 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_18
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            PBL%v = X(K-NX+(-1))%v
            OpenAD_Symbol_99 = (K - NX +(-1))
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_99
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_19 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_19
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          IF(I .eq. 1) THEN
            PB%v = 0.0D00
            PBB%v = X(K)%v
            integer_tape(integer_tape_pointer) = K
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_22 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_22
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            IF(I .eq. 2) THEN
              PB%v = X(K-NX)%v
              PBB%v = 0.0D00
              OpenAD_Symbol_96 = (K - NX)
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_96
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_20 = 1_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_20
              integer_tape_pointer = integer_tape_pointer+1
            ELSE
              PB%v = X(K-NX)%v
              PBB%v = X(K-NX*2)%v
              OpenAD_Symbol_97 = (K - NX)
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_97
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_98 = (K - NX * 2)
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_98
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_21 = 0_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_21
              integer_tape_pointer = integer_tape_pointer+1
            ENDIF
            OpenAD_Symbol_23 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_23
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          IF((NX .eq. J) .OR.(I .eq. 1)) THEN
            PBR%v = 0.0D00
            OpenAD_Symbol_24 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_24
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            PBR%v = X(K-NX+1)%v
            OpenAD_Symbol_95 = (K - NX + 1)
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_95
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_25 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_25
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          IF(J .eq. 1) THEN
            PL%v = 0.0D00
            PLL%v = X(K)%v
            integer_tape(integer_tape_pointer) = K
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_28 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_28
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            IF(J .eq. 2) THEN
              PL%v = X(K+(-1))%v
              PLL%v = 0.0D00
              OpenAD_Symbol_92 = (K +(-1))
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_92
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_26 = 1_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_26
              integer_tape_pointer = integer_tape_pointer+1
            ELSE
              PL%v = X(K+(-1))%v
              PLL%v = X(K+(-2))%v
              OpenAD_Symbol_93 = (K +(-1))
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_93
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_94 = (K +(-2))
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_94
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_27 = 0_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_27
              integer_tape_pointer = integer_tape_pointer+1
            ENDIF
            OpenAD_Symbol_29 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_29
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          P%v = X(K)%v
          integer_tape(integer_tape_pointer) = K
          integer_tape_pointer = integer_tape_pointer+1
          IF(J .eq.(NX +(-1))) THEN
            PR%v = X(K+1)%v
            PRR%v = 0.0D00
            OpenAD_Symbol_84 = (K + 1)
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_84
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_32 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_32
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            IF(NX .eq. J) THEN
              PR%v = 0.0D00
              PRR%v = X(K)%v
              integer_tape(integer_tape_pointer) = K
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_30 = 1_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_30
              integer_tape_pointer = integer_tape_pointer+1
            ELSE
              PR%v = X(K+1)%v
              PRR%v = X(K+2)%v
              OpenAD_Symbol_90 = (K + 1)
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_90
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_91 = (K + 2)
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_91
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_31 = 0_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_31
              integer_tape_pointer = integer_tape_pointer+1
            ENDIF
            OpenAD_Symbol_33 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_33
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          IF((NY .eq. I) .OR.(J .eq. 1)) THEN
            PTL%v = 0.0D00
            OpenAD_Symbol_34 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_34
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            PTL%v = X(NX+K+(-1))%v
            OpenAD_Symbol_89 = (NX + K +(-1))
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_89
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_35 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_35
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          IF(I .eq.(NY +(-1))) THEN
            PT%v = X(NX+K)%v
            PTT%v = 0.0D00
            OpenAD_Symbol_85 = (NX + K)
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_85
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_38 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_38
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            IF(NY .eq. I) THEN
              PT%v = 0.0D00
              PTT%v = X(K)%v
              integer_tape(integer_tape_pointer) = K
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_36 = 1_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_36
              integer_tape_pointer = integer_tape_pointer+1
            ELSE
              PT%v = X(NX+K)%v
              PTT%v = X(K+NX*2)%v
              OpenAD_Symbol_87 = (NX + K)
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_87
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_88 = (K + NX * 2)
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_88
              integer_tape_pointer = integer_tape_pointer+1
              OpenAD_Symbol_37 = 0_w2f__i8
              integer_tape(integer_tape_pointer) = OpenAD_Symbol_37
              integer_tape_pointer = integer_tape_pointer+1
            ENDIF
            OpenAD_Symbol_39 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_39
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          IF((NX .eq. J) .OR.(NY .eq. I)) THEN
            PTR%v = 0.0D00
            OpenAD_Symbol_40 = 1_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_40
            integer_tape_pointer = integer_tape_pointer+1
          ELSE
            PTR%v = X(NX+K+1)%v
            OpenAD_Symbol_86 = (NX + K + 1)
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_86
            integer_tape_pointer = integer_tape_pointer+1
            OpenAD_Symbol_41 = 0_w2f__i8
            integer_tape(integer_tape_pointer) = OpenAD_Symbol_41
            integer_tape_pointer = integer_tape_pointer+1
          ENDIF
          OpenAD_tmp_0 = (PT%v-PB%v)
          OpenAD_tmp_1 = (HY * 2.0D00)
          DPDY%v = (OpenAD_tmp_0/OpenAD_tmp_1)
          OpenAD_lin_0 = (INT(1_w2f__i8) / OpenAD_tmp_1)
          OpenAD_tmp_2 = (PR%v-PL%v)
          OpenAD_tmp_3 = (HX * 2.0D00)
          DPDX%v = (OpenAD_tmp_2/OpenAD_tmp_3)
          OpenAD_lin_2 = (INT(1_w2f__i8) / OpenAD_tmp_3)
          OpenAD_tmp_4 = (PBB%v+P%v-PB%v*2.0D00)
          OpenAD_tmp_5 = (PBL%v+PBR%v-PB%v*2.0D00)
          PBLAP%v = ((OpenAD_tmp_4/HY2)+(OpenAD_tmp_5/HX2))
          OpenAD_lin_4 = (INT(1_w2f__i8) / HY2)
          OpenAD_lin_7 = (INT(1_w2f__i8) / HX2)
          OpenAD_tmp_6 = (PBL%v+PTL%v-PL%v*2.0D00)
          OpenAD_tmp_7 = (PLL%v+P%v-PL%v*2.0D00)
          PLLAP%v = ((OpenAD_tmp_6/HY2)+(OpenAD_tmp_7/HX2))
          OpenAD_lin_10 = (INT(1_w2f__i8) / HY2)
          OpenAD_lin_13 = (INT(1_w2f__i8) / HX2)
          OpenAD_tmp_8 = (PB%v+PT%v-P%v*2.0D00)
          OpenAD_tmp_9 = (PL%v+PR%v-P%v*2.0D00)
          PLAP%v = ((OpenAD_tmp_8/HY2)+(OpenAD_tmp_9/HX2))
          OpenAD_lin_16 = (INT(1_w2f__i8) / HY2)
          OpenAD_lin_19 = (INT(1_w2f__i8) / HX2)
          OpenAD_tmp_10 = (P%v+PRR%v-PR%v*2.0D00)
          OpenAD_tmp_11 = (PBR%v+PTR%v-PR%v*2.0D00)
          PRLAP%v = ((OpenAD_tmp_10/HX2)+(OpenAD_tmp_11/HY2))
          OpenAD_lin_22 = (INT(1_w2f__i8) / HX2)
          OpenAD_lin_25 = (INT(1_w2f__i8) / HY2)
          OpenAD_tmp_12 = (P%v+PTT%v-PT%v*2.0D00)
          OpenAD_tmp_13 = (PTL%v+PTR%v-PT%v*2.0D00)
          PTLAP%v = ((OpenAD_tmp_12/HY2)+(OpenAD_tmp_13/HX2))
          OpenAD_lin_28 = (INT(1_w2f__i8) / HY2)
          OpenAD_lin_31 = (INT(1_w2f__i8) / HX2)
          OpenAD_tmp_14 = (PBLAP%v+PTLAP%v-PLAP%v*2.0D00)
          OpenAD_tmp_15 = (PLLAP%v+PRLAP%v-PLAP%v*2.0D00)
          OpenAD_tmp_19 = (PRLAP%v-PLLAP%v)
          OpenAD_tmp_17 = (DPDY%v*OpenAD_tmp_19)
          OpenAD_tmp_18 = (HX * 2.0D00)
          OpenAD_tmp_22 = (PTLAP%v-PBLAP%v)
          OpenAD_tmp_20 = (DPDX%v*OpenAD_tmp_22)
          OpenAD_tmp_21 = (HY * 2.0D00)
          OpenAD_tmp_16 = ((OpenAD_tmp_17 / OpenAD_tmp_18) -(
     > OpenAD_tmp_20 / OpenAD_tmp_21))
          FVEC(INT(K))%v = ((OpenAD_tmp_14/HY2)+(OpenAD_tmp_15/HX2)-R*Op
     +enAD_tmp_16)
          OpenAD_lin_34 = (INT(1_w2f__i8) / HY2)
          OpenAD_lin_37 = (INT(1_w2f__i8) / HX2)
          OpenAD_lin_44 = OpenAD_tmp_19
          OpenAD_lin_45 = DPDY%v
          OpenAD_lin_42 = (INT(1_w2f__i8) / OpenAD_tmp_18)
          OpenAD_lin_48 = OpenAD_tmp_22
          OpenAD_lin_49 = DPDX%v
          OpenAD_lin_46 = (INT(1_w2f__i8) / OpenAD_tmp_21)
          OpenAD_lin_41 = R
          OpenAD_acc_0 = (OpenAD_lin_41 * INT((-1_w2f__i8)))
          OpenAD_acc_1 = (INT((-1_w2f__i8)) * OpenAD_acc_0)
          OpenAD_acc_2 = (OpenAD_lin_49 * OpenAD_lin_46 * OpenAD_acc_1)
          OpenAD_acc_3 = (OpenAD_lin_2 * OpenAD_lin_48 * OpenAD_lin_46
     >  * OpenAD_acc_1)
          OpenAD_acc_4 = (OpenAD_lin_45 * OpenAD_lin_42 * OpenAD_acc_0)
          OpenAD_acc_5 = (OpenAD_lin_0 * OpenAD_lin_44 * OpenAD_lin_42
     >  * OpenAD_acc_0)
          OpenAD_acc_6 = (OpenAD_lin_37 + OpenAD_acc_4)
          OpenAD_acc_7 = (OpenAD_lin_37 + INT((-1_w2f__i8)) *
     >  OpenAD_acc_4)
          OpenAD_acc_8 = (2.0D00 * INT((-1_w2f__i8)) * OpenAD_lin_37 +
     >  2.0D00 * INT((-1_w2f__i8)) * OpenAD_lin_34)
          OpenAD_acc_9 = (OpenAD_lin_34 + OpenAD_acc_2)
          OpenAD_acc_10 = (OpenAD_lin_34 + INT((-1_w2f__i8)) *
     >  OpenAD_acc_2)
          OpenAD_acc_11 = (OpenAD_lin_31 * OpenAD_acc_9)
          OpenAD_acc_12 = (OpenAD_lin_28 * OpenAD_acc_9)
          OpenAD_acc_13 = (OpenAD_lin_25 * OpenAD_acc_6)
          OpenAD_acc_14 = (OpenAD_lin_22 * OpenAD_acc_6)
          OpenAD_acc_15 = (OpenAD_lin_19 * OpenAD_acc_8)
          OpenAD_acc_16 = (OpenAD_lin_16 * OpenAD_acc_8)
          OpenAD_acc_17 = (OpenAD_lin_13 * OpenAD_acc_7)
          OpenAD_acc_18 = (OpenAD_lin_10 * OpenAD_acc_7)
          OpenAD_acc_19 = (OpenAD_lin_7 * OpenAD_acc_10)
          OpenAD_acc_20 = (OpenAD_lin_4 * OpenAD_acc_10)
          double_tape(double_tape_pointer) = OpenAD_acc_3
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_5
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_11
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_12
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_13
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_14
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_15
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_16
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_17
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_18
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_19
          double_tape_pointer = double_tape_pointer+1
          double_tape(double_tape_pointer) = OpenAD_acc_20
          double_tape_pointer = double_tape_pointer+1
          integer_tape(integer_tape_pointer) = K
          integer_tape_pointer = integer_tape_pointer+1
          OpenAD_Symbol_17 = (INT(OpenAD_Symbol_17) + INT(1_w2f__i8))
        END DO
        integer_tape(integer_tape_pointer) = OpenAD_Symbol_17
        integer_tape_pointer = integer_tape_pointer+1
        OpenAD_Symbol_16 = (INT(OpenAD_Symbol_16) + INT(1_w2f__i8))
      END DO
      integer_tape(integer_tape_pointer) = OpenAD_Symbol_16
      integer_tape_pointer = integer_tape_pointer+1

          end if 
          if (our_rev_mode%adjoint) then
! adjoint
      integer_tape_pointer = integer_tape_pointer-1
      OpenAD_Symbol_0 = integer_tape(integer_tape_pointer)
      OpenAD_Symbol_1 = 1
      DO WHILE(INT(OpenAD_Symbol_1) .LE. INT(OpenAD_Symbol_0))
        integer_tape_pointer = integer_tape_pointer-1
        OpenAD_Symbol_2 = integer_tape(integer_tape_pointer)
        OpenAD_Symbol_3 = 1
        DO WHILE(INT(OpenAD_Symbol_3) .LE. INT(OpenAD_Symbol_2))
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_105 = integer_tape(integer_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_106 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_107 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_108 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_109 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_110 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_111 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_112 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_113 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_114 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_115 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_116 = double_tape(double_tape_pointer)
          double_tape_pointer = double_tape_pointer-1
          OpenAD_Symbol_117 = double_tape(double_tape_pointer)
          OpenAD_prop_2%d = OpenAD_prop_2%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_106)
          OpenAD_prop_3%d = OpenAD_prop_3%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_107)
          OpenAD_prop_4%d = OpenAD_prop_4%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_108)
          OpenAD_prop_5%d = OpenAD_prop_5%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_109)
          OpenAD_prop_6%d = OpenAD_prop_6%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_110)
          OpenAD_prop_7%d = OpenAD_prop_7%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_111)
          OpenAD_prop_8%d = OpenAD_prop_8%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_112)
          OpenAD_prop_9%d = OpenAD_prop_9%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_113)
          OpenAD_prop_10%d = OpenAD_prop_10%d+FVEC(INT(OpenAD_Symbol_105
     +))%d*(OpenAD_Symbol_114)
          OpenAD_prop_11%d = OpenAD_prop_11%d+FVEC(INT(OpenAD_Symbol_105
     +))%d*(OpenAD_Symbol_115)
          OpenAD_prop_0%d = OpenAD_prop_0%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_116)
          OpenAD_prop_1%d = OpenAD_prop_1%d+FVEC(INT(OpenAD_Symbol_105))
     +%d*(OpenAD_Symbol_117)
          FVEC(INT(OpenAD_Symbol_105))%d = 0.0d0
          PT%d = PT%d+OpenAD_prop_11%d*(-2.0D00)
          PTR%d = PTR%d+OpenAD_prop_11%d
          PTL%d = PTL%d+OpenAD_prop_11%d
          OpenAD_prop_11%d = 0.0d0
          PT%d = PT%d+OpenAD_prop_10%d*(-2.0D00)
          PTT%d = PTT%d+OpenAD_prop_10%d
          P%d = P%d+OpenAD_prop_10%d
          OpenAD_prop_10%d = 0.0d0
          PR%d = PR%d+OpenAD_prop_9%d*(-2.0D00)
          PTR%d = PTR%d+OpenAD_prop_9%d
          PBR%d = PBR%d+OpenAD_prop_9%d
          OpenAD_prop_9%d = 0.0d0
          PR%d = PR%d+OpenAD_prop_8%d*(-2.0D00)
          PRR%d = PRR%d+OpenAD_prop_8%d
          P%d = P%d+OpenAD_prop_8%d
          OpenAD_prop_8%d = 0.0d0
          P%d = P%d+OpenAD_prop_7%d*(-2.0D00)
          PR%d = PR%d+OpenAD_prop_7%d
          PL%d = PL%d+OpenAD_prop_7%d
          OpenAD_prop_7%d = 0.0d0
          P%d = P%d+OpenAD_prop_6%d*(-2.0D00)
          PT%d = PT%d+OpenAD_prop_6%d
          PB%d = PB%d+OpenAD_prop_6%d
          OpenAD_prop_6%d = 0.0d0
          PL%d = PL%d+OpenAD_prop_5%d*(-2.0D00)
          P%d = P%d+OpenAD_prop_5%d
          PLL%d = PLL%d+OpenAD_prop_5%d
          OpenAD_prop_5%d = 0.0d0
          PL%d = PL%d+OpenAD_prop_4%d*(-2.0D00)
          PTL%d = PTL%d+OpenAD_prop_4%d
          PBL%d = PBL%d+OpenAD_prop_4%d
          OpenAD_prop_4%d = 0.0d0
          PB%d = PB%d+OpenAD_prop_3%d*(-2.0D00)
          PBR%d = PBR%d+OpenAD_prop_3%d
          PBL%d = PBL%d+OpenAD_prop_3%d
          OpenAD_prop_3%d = 0.0d0
          PB%d = PB%d+OpenAD_prop_2%d*(-2.0D00)
          P%d = P%d+OpenAD_prop_2%d
          PBB%d = PBB%d+OpenAD_prop_2%d
          OpenAD_prop_2%d = 0.0d0
          PL%d = PL%d-OpenAD_prop_1%d
          PR%d = PR%d+OpenAD_prop_1%d
          OpenAD_prop_1%d = 0.0d0
          PB%d = PB%d-OpenAD_prop_0%d
          PT%d = PT%d+OpenAD_prop_0%d
          OpenAD_prop_0%d = 0.0d0
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_4 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_4 .ne. 0) THEN
            PTR%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_118 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_118))%d = X(INT(OpenAD_Symbol_118))%d+PT
     +R%d
            PTR%d = 0.0d0
          ENDIF
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_5 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_5 .ne. 0) THEN
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_104 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_104))%d = X(INT(OpenAD_Symbol_104))%d+PT
     +%d
            PT%d = 0.0d0
            PTT%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_6 = integer_tape(integer_tape_pointer)
            IF(OpenAD_Symbol_6 .ne. 0) THEN
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_119 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_119))%d = X(INT(OpenAD_Symbol_119))%d+
     +PTT%d
              PTT%d = 0.0d0
              PT%d = 0.0d0
            ELSE
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_120 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_120))%d = X(INT(OpenAD_Symbol_120))%d+
     +PTT%d
              PTT%d = 0.0d0
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_121 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_121))%d = X(INT(OpenAD_Symbol_121))%d+
     +PT%d
              PT%d = 0.0d0
            ENDIF
          ENDIF
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_7 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_7 .ne. 0) THEN
            PTL%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_122 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_122))%d = X(INT(OpenAD_Symbol_122))%d+PT
     +L%d
            PTL%d = 0.0d0
          ENDIF
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_8 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_8 .ne. 0) THEN
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_103 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_103))%d = X(INT(OpenAD_Symbol_103))%d+PR
     +%d
            PR%d = 0.0d0
            PRR%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_9 = integer_tape(integer_tape_pointer)
            IF(OpenAD_Symbol_9 .ne. 0) THEN
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_123 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_123))%d = X(INT(OpenAD_Symbol_123))%d+
     +PRR%d
              PRR%d = 0.0d0
              PR%d = 0.0d0
            ELSE
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_124 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_124))%d = X(INT(OpenAD_Symbol_124))%d+
     +PRR%d
              PRR%d = 0.0d0
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_125 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_125))%d = X(INT(OpenAD_Symbol_125))%d+
     +PR%d
              PR%d = 0.0d0
            ENDIF
          ENDIF
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_102 = integer_tape(integer_tape_pointer)
          X(INT(OpenAD_Symbol_102))%d = X(INT(OpenAD_Symbol_102))%d+P%d
          P%d = 0.0d0
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_10 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_10 .ne. 0) THEN
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_101 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_101))%d = X(INT(OpenAD_Symbol_101))%d+PL
     +L%d
            PLL%d = 0.0d0
            PL%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_11 = integer_tape(integer_tape_pointer)
            IF(OpenAD_Symbol_11 .ne. 0) THEN
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_126 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_126))%d = X(INT(OpenAD_Symbol_126))%d+
     +PL%d
              PL%d = 0.0d0
              PLL%d = 0.0d0
            ELSE
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_127 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_127))%d = X(INT(OpenAD_Symbol_127))%d+
     +PLL%d
              PLL%d = 0.0d0
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_128 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_128))%d = X(INT(OpenAD_Symbol_128))%d+
     +PL%d
              PL%d = 0.0d0
            ENDIF
          ENDIF
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_12 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_12 .ne. 0) THEN
            PBR%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_129 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_129))%d = X(INT(OpenAD_Symbol_129))%d+PB
     +R%d
            PBR%d = 0.0d0
          ENDIF
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_13 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_13 .ne. 0) THEN
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_100 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_100))%d = X(INT(OpenAD_Symbol_100))%d+PB
     +B%d
            PBB%d = 0.0d0
            PB%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_14 = integer_tape(integer_tape_pointer)
            IF(OpenAD_Symbol_14 .ne. 0) THEN
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_130 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_130))%d = X(INT(OpenAD_Symbol_130))%d+
     +PB%d
              PB%d = 0.0d0
              PBB%d = 0.0d0
            ELSE
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_131 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_131))%d = X(INT(OpenAD_Symbol_131))%d+
     +PBB%d
              PBB%d = 0.0d0
              integer_tape_pointer = integer_tape_pointer-1
              OpenAD_Symbol_132 = integer_tape(integer_tape_pointer)
              X(INT(OpenAD_Symbol_132))%d = X(INT(OpenAD_Symbol_132))%d+
     +PB%d
              PB%d = 0.0d0
            ENDIF
          ENDIF
          integer_tape_pointer = integer_tape_pointer-1
          OpenAD_Symbol_15 = integer_tape(integer_tape_pointer)
          IF(OpenAD_Symbol_15 .ne. 0) THEN
            PBL%d = 0.0d0
          ELSE
            integer_tape_pointer = integer_tape_pointer-1
            OpenAD_Symbol_133 = integer_tape(integer_tape_pointer)
            X(INT(OpenAD_Symbol_133))%d = X(INT(OpenAD_Symbol_133))%d+PB
     +L%d
            PBL%d = 0.0d0
          ENDIF
          OpenAD_Symbol_3 = INT(OpenAD_Symbol_3) + 1
        END DO
        OpenAD_Symbol_1 = INT(OpenAD_Symbol_1) + 1
      END DO

          end if 
        end subroutine head
